
const MAIN_NOTICE_GRID_ID = '#ITP_MAIN_NOTICE_jqGrid';
const MAIN_NOTICE_GRID_LIST = '#ITP_MAIN_NOTICE_jqGrid_list';
const MAIN_NOTICE_GRID_PAGER = '#ITP_MAIN_NOTICE_jqGridPager';
const MAIN_NOTICE_GRID_EMPTY = '#ITP_MAIN_NOTICE_jqGridEmpty';

let NTICE_DETAIL_GRID_LIST = '/api/ntice/main-detail-grid-list';

require(['config'], function() {
	require([
		'jquery', 
		'jquery.bootstrap.fileUpload' //파일 업로드가 있는 페이지에서 로딩
	], function($) {
		
		setTimeout(function() {
			// 시간지정
			// $('#ITP_FORM_MAIN_NOTICE_SEARCH_SCH_DT').val(itp_fn_date_format(new Date(), 2));
			// $('#ITP_FORM_MAIN_NOTICE_SEARCH_USER_ID').val(fn_make_user_info.get('userId'));
			
			// 그리드
			// itp_fn_MAIN_NOTICE_grid.init();
	    	// itp_fn_fire_window_resize();

			// 조회
	    	itp_fn_MAIN_NOTICE_search();			

		}, 500);
				
	});
});

//그래프 
google.charts.load('current', {'packages':['corechart']});
google.charts.load('current', {'packages':['bar']});

google.charts.setOnLoadCallback(drawChartReq);
google.charts.setOnLoadCallback(drawChartPodr);
google.charts.setOnLoadCallback(drawChartReqUp);
google.charts.setOnLoadCallback(drawChartcore);
google.charts.setOnLoadCallback(drawLine);

//구매요청 그래프
function drawChartReq() {
  var data = google.visualization.arrayToDataTable([
    ['구매요청', '대기', '반려', '승인',],
    ['2014', 4.2 , 2.5 , 2]
  ]);

  var options = {
    	legend: { position: 'left' }
  };

  var chart = new google.charts.Bar(document.getElementById('ITP_PCH_REQ_GRAPH'));

  chart.draw(data, options);
}

//구매발주 그래프
function drawChartPodr() {
	  var data = google.visualization.arrayToDataTable([
	    ['구매발주', '요청', '진행', '취소'],
	    ['2014', 3.5, 1.7, 1.2]
	  ]);

	  var options = {
	    	legend: { position: 'left' }	
	  };

	  var chart = new google.charts.Bar(document.getElementById('ITP_PCH_PODR_GRAPH'));

	  chart.draw(data, options);
	}

//구매요청 상위 품목 그리드
function drawChartReqUp() {
  var data = google.visualization.arrayToDataTable([
    ['Year', '품목5', '품목4', '품목3','품목2','품목1'],
    ['항목 1', 17, 15, 12, 10, 8],
  ]);

  var options = {
      title: '구매요청 상위 품목(일주일)',
	  legend: { position: 'left' },
	  bars: 'horizontal'
  };

  var chart = new google.charts.Bar(document.getElementById('ITP_PCH_REQ_UP_ITEM_GRAPH'));

  chart.draw(data, options);
}

//정산 그래프
function drawChartcore() {

    var data = google.visualization.arrayToDataTable([
      ['Task', 'Hours per Day'],
      ['요청', 25],
      ['확인', 65],
      ['반려', 10],
    ]);

    var options = {
		title: '정산',
		legend: { position: 'left' }	
    };

    var chart = new google.visualization.PieChart(document.getElementById('ITP_STTL_GRAPH'));

    chart.draw(data, options);
  }


function drawLine() {
  var data = google.visualization.arrayToDataTable([
    ['Year', '안전재고수량', '현재재고수량'],
    ['품목1',  1000,      400],
    ['품목2',  1170,      460],
    ['품목3',  660,       1120],
    ['품목4',  1660,      120],
    ['품목5',  660,       520],
  ]);

  var options = {
    title: '',
    width: 900,
    legend: { position: 'top' }
  };

  var chart = new google.visualization.LineChart(document.getElementById('ITP_SAFE_STCK_GRAPH'));

  chart.draw(data, options);
}

var itp_fn_MAIN_NOTICE_grid = {
	init: function() {
		// 데이터 없을때
		itp_fn_MAIN_NOTICE_empty.push();
		$(MAIN_NOTICE_GRID_EMPTY).on('click', function() {
			itp_fn_MAIN_NOTICE_empty.back();
			itp_MAIN_NOTICE_param.gridSize = $.jgrid.defaults.rowNum;
			$(MAIN_NOTICE_GRID_ID).setGridParam({'postData': JSON.stringify(itp_MAIN_NOTICE_param)}).trigger('reloadGrid');
		});
		console.log("grid init", MAIN_NOTICE_GRID_LIST);
		itp_fn_jqgrid_resize(MAIN_NOTICE_GRID_ID, MAIN_NOTICE_GRID_LIST, 'lg');
	},
	callBack: function() {
		let param = $('#ITP_FORM_MAIN_NOTICE_SEARCH').serializeObject();
		param.gridSize = $.jgrid.defaults.rowNum;
		$(MAIN_NOTICE_GRID_ID).jqGrid({
			colModel: [
				{
					index: 'NTICE_NO', name: 'nticeNo',
					label: ITP_MSG_LOCALE.label.notiNo, //공지번호
					width: '10', fixed: false, align: 'center',
					sortable: false, hidden: false
				},
				{
					index: 'NTICE_TITL', name: 'nticeTitl',
					label: '공지사항', //공지제목
					width: '15', fixed: false, align: 'left',
					sortable: false, hidden: false
				},
				{
					index: 'ADD_DT', name: 'addDt',
					label: ITP_MSG_LOCALE.label.regDt, //등록일
					width: '10', fixed: false, align: 'center',
					sortable: false, hidden: false
				}
			],
			loadBeforeSend: function(jqXHR) {
			    jqXHR.setRequestHeader('X-AUTH-TOKEN', CONN_KEY);
			},
			postData: JSON.stringify(param),
			url: DOMAIN + NTICE_DETAIL_GRID_LIST,
			pager: MAIN_NOTICE_GRID_PAGER,
			multiselect: false,
			rownumbers: true,
			onCellSelect: function(rowId, cellIdx, cellValue) {
				var cm = $(this).jqGrid('getGridParam', 'colModel');
				var colNm = cm[cellIdx].name;
				if (colNm == 'nticeTitl') {
					const nticeNoVal = $(this).jqGrid('getCell', rowId, 'nticeNo');
					const key = {nticeNo: nticeNoVal, viewCd: 'R'};
					var param = $.param(key);
					// itp_fn_MAIN_NOTICE_view(param);
					
					fn_call_popup('comm', 'NOTICE_INFO_POPUP', '#ITP_ASIDE', function() {
												
					}, param, 'S');
					$('#ITP_NOTICE_INFO_POPUP > div.modal-dialog').width('500px');
				}
		   	},
			loadComplete: function(data) {
				
				console.log('>>>>> ' + JSON.stringify(data));
				
				itp_fn_grid_load_complete(data, MAIN_NOTICE_GRID_ID, true, 'number', 'MAIN_NOTICE', itp_MAIN_NOTICE_search, itp_fn_MAIN_NOTICE_empty, false, data.gridRecords, true);
				var ids = $(MAIN_NOTICE_GRID_ID).getDataIDs();
				$.each(ids, function(idx, rowId) {
					$(MAIN_NOTICE_GRID_ID).jqGrid('setCell', rowId, 'nticeTitl', '', ITP_GRID_COL_STYLE.link);
				});

				if ($('#ITP_CONTAINER').data('openYn') == 'Y') {
					$('#ITP_CONTAINER').data('openYn', 'N');
					const keyNew = {nticeNo: $('#ITP_CONTAINER').data('nticeNo'), viewCd: 'R'};
					var paramNew = $.param(keyNew);
					itp_fn_MAIN_NOTICE_view(paramNew);
				}
		    },
		    loadError: function(jqXHR, textStatus, errorThrown) {
		    	itp_fn_grid_load_error(jqXHR, textStatus, errorThrown);
		    },
		    onPaging: function(action) {
		    	itp_fn_grid_paging(MAIN_NOTICE_GRID_ID, action, param);
		    }
		}).navGrid(MAIN_NOTICE_GRID_PAGER, ITP_GRID_NAV_DEFAULTS.navGrid);
	},
	clearData : function() {
		$(MAIN_NOTICE_GRID_ID).jqGrid('clearGridData', true);
		$(MAIN_NOTICE_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
		$(MAIN_NOTICE_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
		$(MAIN_NOTICE_GRID_EMPTY).show();
	},
	unload : function() {
		$.jgrid.gridUnload(MAIN_NOTICE_GRID_ID);
	}
};

var itp_fn_MAIN_NOTICE_search = function() {
	// itp_fn_MAIN_NOTICE_grid.unload();
	// itp_fn_MAIN_NOTICE_grid.callBack();
	// 공지사항 조회
	const formId = '#ITP_FORM_MAIN_SEARCH';
	let param = $(formId).serializeObject();
	var searhFn = function(result) {
		console.log('>>>>>> ' + JSON.stringify(result));
	};
	fn_ajax_call(NTICE_DETAIL_GRID_LIST, JSON.stringify(param), searhFn, 'POST');
};

let itp_MAIN_NOTICE_param = {};
let itp_MAIN_NOTICE_search = false;
var itp_fn_MAIN_NOTICE_empty = {
	push: function() {		
		let param = $('#ITP_FORM_MAIN_NOTICE_SEARCH').serializeObject();
		itp_MAIN_NOTICE_param = param;
	},
	back: function() {
		
	}
};
